#!/bin/bash
###############################################################
################## v2/v3 scanner ##############################
# a little bash script to scan the darkweb for tor addresses
# adjust the proxy variables in /etc/lynx/lynx.cfg if needed
# than just call the script from a subdir, and let run
# you will need a file called "links.txt" containing onion
# links to start the script of (there are some popular 
# addresses preloaded).
# the script runs in an endless loop until there are no more
# links to be followed. you can stop anytime with CTRL+C
# without loosing anything but the currently
# running request. Another start of the script, and it will
# pickup where it was interrupted. all of this is
# EXPERIMENTAL CODE, USE AT OWN RISK
# version 0.11
###############################################################
max_links=5
counter=0
up=0
down=0
touch ./up.txt
touch ./down.txt
touch ./visited_links.txt
touch ./blocklist.txt
touch ./down.txt
touch ./max_visit.txt
while true
do
	counter=$(("$counter"+1))
	up=$(wc -l up.txt | cut -f1 -d' ')
	down=$(wc -l down.txt | cut -f1 -d' ')
	sort -u links.txt | grep -E 'http:\/\/[[:alnum:]]{16,56}\.onion.*' | sort > links_new.txt && mv links_new.txt links.txt
	sort -u links.txt | grep -o -E 'http:\/\/[[:alnum:]]{16,56}\.onion' | sort -u | sort > hosts.txt
	sort -u visited_links.txt | sort > visited_links_new.txt && mv visited_links_new.txt visited_links.txt
	sort -u max_visit.txt | sort > max_visit_new.txt && mv max_visit_new.txt max_visit.txt
	sort -u down.txt | sort > down_new.txt && mv down_new.txt down.txt
	sort -u up.txt | sort > up_new.txt && mv up_new.txt up.txt
	comm -23 links.txt visited_links.txt > links_new.txt && mv links_new.txt links.txt
	comm -23 hosts.txt blocklist.txt > hosts_new.txt && mv hosts_new.txt hosts.txt
	comm -23 hosts.txt down.txt > hosts_new.txt && mv hosts_new.txt hosts.txt
	comm -23 hosts.txt max_visit.txt > hosts_new.txt && mv hosts_new.txt hosts.txt
	visited_link_count=$(wc -l visited_links.txt | cut -f1 -d ' ')
	link_count=$(wc -l links.txt | cut -f1 -d ' ')
	service_count=$(wc -l hosts.txt | cut -f1 -d' ')
	visited_service_count=$(grep -E -o 'http:\/\/[[:alnum:]]{16,56}\.onion' visited_links.txt | sort -u | wc -l)
	echo -e "We have tried to visit $visited_link_count links on $visited_service_count hosts, found $up hosts up, and $down hosts down. We still have $link_count unique links on $service_count hosts\n\r"
	service=$(sort -R hosts.txt | head -n 1)
	service_dir=$(echo "$service" | cut -c8- | rev | cut -c7- | rev)
	echo -e "checking if $service is up or not\n\r"
	if lynx -head -dump "$service" 2>&1 | grep -w "200" ; then
		if [ ! -d "./hosts/$service_dir" ]; then
			mkdir "hosts/$service_dir"
			touch "hosts/$service_dir/links.txt" 
		fi
    		echo "$service is up"
		echo "$service" >> up.txt
		link=$(sort -R "hosts/$service_dir/links.txt" | head -n 1)
		if [ -z "$link" ]; then
			echo "no specific links for $service, using onion address"
			link="$service"
		fi
		echo -e "trying to get $link in run number $counter,\n\r"
		echo "$link" >> visited_links.txt
		lynx -dump -listonly "$link" | grep -E 'http:\/\/[[:alnum:]]{16,56}\.onion.*' | grep -E -i -v '.*\.jpg$|.*\.gif$|.*\.png$|.*\.pdf$|.*\.mp3$|.*\.m3u$|.*\.avi$|.*\.jpeg$|.*\.bmp$|.*\.mkv$' | cut -f2- -d '.' | cut -c2- >> "hosts/$service_dir/links.txt"
		echo "$link" >> "hosts/$service_dir/visited_links.txt"
		link_count=$(wc -l "hosts/$service_dir/visited_links.txt" | cut -f1 -d' ')
		if [ "$link_count" -ge $max_links ]; then
			echo "$service" >> max_visit.txt
		fi
		echo "$(<hosts/$service_dir/links.txt )" >> ./links.txt
	else
		echo "$service is down"
		echo "$service" >> down.txt
	fi

done

